SystemOrganization addCategory: #BinarySearch!

Object subclass: #BinarySearchLogic
	instanceVariableNames: 'eq left right root'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BinarySearch'!

!BinarySearchLogic methodsFor: 'as yet unclassified' stamp: 'hjo 11/14/2010 14:09'!
equation

	^eq! !

!BinarySearchLogic methodsFor: 'as yet unclassified' stamp: 'hjo 11/14/2010 14:09'!
equation: aBlock

	"equation must be monotone function"
	self left equation: aBlock.
	self right equation: aBlock.
	eq := aBlock! !

!BinarySearchLogic methodsFor: 'as yet unclassified' stamp: 'hjo 11/14/2010 14:10'!
left

	left isNil ifTrue: [ left := PointOnFunction new ].
	^left! !

!BinarySearchLogic methodsFor: 'as yet unclassified' stamp: 'hjo 11/14/2010 14:10'!
left: aNumber

	^self left x: aNumber! !

!BinarySearchLogic methodsFor: 'as yet unclassified' stamp: 'hjo 11/14/2010 14:11'!
newPointOnFunction

	^PointOnFunction new
		equation: self equation;
		yourself
! !

!BinarySearchLogic methodsFor: 'as yet unclassified' stamp: 'hjo 11/20/2010 21:54'!
printXOfLeftRightOnTranscript

	Transcript print: self left x; space; space; print: self right x; cr; flush! !

!BinarySearchLogic methodsFor: 'as yet unclassified' stamp: 'hjo 11/20/2010 21:55'!
printYOfLeftRightOnTranscript

	Transcript print: self left y; space; space; print: self right y; cr; flush! !

!BinarySearchLogic methodsFor: 'as yet unclassified' stamp: 'hjo 11/14/2010 14:11'!
pseudoSolution

	^(self left x + self right x) / 2! !

!BinarySearchLogic methodsFor: 'as yet unclassified' stamp: 'hjo 11/14/2010 14:12'!
range: aRange 

	self left: aRange start.
	self right: aRange stop! !

!BinarySearchLogic methodsFor: 'as yet unclassified' stamp: 'hjo 11/14/2010 14:12'!
reset

	root isNil ifFalse: [
	self left x: self left x - Float epsilon.
	self right x: self right x + Float epsilon].
	root := nil! !

!BinarySearchLogic methodsFor: 'as yet unclassified' stamp: 'hjo 11/14/2010 14:12'!
right

	right isNil ifTrue: [ right := PointOnFunction new ].
	^right
! !

!BinarySearchLogic methodsFor: 'as yet unclassified' stamp: 'hjo 11/14/2010 14:12'!
right: aNumber

	^self right x: aNumber! !

!BinarySearchLogic methodsFor: 'as yet unclassified' stamp: 'hjo 11/14/2010 14:12'!
root

	^root! !

!BinarySearchLogic methodsFor: 'as yet unclassified' stamp: 'hjo 11/14/2010 14:13'!
solution

	self solve.
	^self root x! !

!BinarySearchLogic methodsFor: 'as yet unclassified' stamp: 'hjo 11/21/2010 12:32'!
solve

	self reset.
	self run.
	^root x
! !

!BinarySearchLogic methodsFor: 'as yet unclassified' stamp: 'hjo 11/21/2010 15:00'!
step

	^self loopCondition ifTrue: [self stepOperation. true] ifFalse: [false]! !

!BinarySearchLogic methodsFor: 'as yet unclassified' stamp: 'hjo 11/14/2010 14:20'!
stepOperation

	self shouldSearchOutside
		ifTrue: [ self jumpToOutsideOfLeftAndRight ]
		ifFalse: [ self jumpToMiddleOfLeftAndRight ]
! !

!BinarySearchLogic methodsFor: 'as yet unclassified' stamp: 'hjo 11/14/2010 14:14'!
value: aNumber

	^self equation value: aNumber! !

!BinarySearchLogic methodsFor: 'as yet unclassified' stamp: 'hjo 11/14/2010 14:14'!
widenBy: aNumber

	self left x: self left x - aNumber.
	self right x: self right x + aNumber! !

BinarySearchLogic subclass: #BinarySearcher
	instanceVariableNames: 'e'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BinarySearch'!

!BinarySearcher methodsFor: 'as yet unclassified' stamp: 'hjo 11/14/2010 14:26'!
accuracy

	^e! !

!BinarySearcher methodsFor: 'as yet unclassified' stamp: 'hjo 11/14/2010 14:26'!
accuracy: aNumber

	e := aNumber abs! !

!BinarySearcher methodsFor: 'as yet unclassified' stamp: 'hjo 3/24/2008 10:27'!
equalsZero: aNumber

	^aNumber abs <= self accuracy! !

!BinarySearcher methodsFor: 'as yet unclassified' stamp: 'hjo 3/24/2008 10:27'!
jumpToMiddleOfLeftAndRight
	
	| new |
	
	new := self newPointOnFunction.

	new x: (left x+right x)/2.
	(new ySignSameWith: left) ifFalse: [ right := new ].
	(new ySignSameWith: right) ifFalse: [ left := new ]! !

!BinarySearcher methodsFor: 'as yet unclassified' stamp: 'hjo 3/24/2008 10:27'!
jumpToOutsideOfLeftAndRight
	
	| new bigger smaller |
	
	new := self newPointOnFunction.
		
	bigger := left biggerYAbsolute: right.
	smaller := left smallerYAbsolute: right.
	
	new x: 2*smaller x - bigger x.
	smaller x: bigger x.
	bigger x: new x! !

!BinarySearcher methodsFor: 'as yet unclassified' stamp: 'hjo 3/24/2008 10:27'!
loopCondition

	(self equalsZero: left y) ifTrue: [ root := left ].
	(self equalsZero: right y) ifTrue: [ root := right ].
	(self left x equals: self right x) ifTrue: [ root := left ].
	^root isNil! !

!BinarySearcher methodsFor: 'as yet unclassified' stamp: 'hjo 3/24/2008 10:27'!
run

	[self step] whileTrue! !

!BinarySearcher methodsFor: 'as yet unclassified' stamp: 'hjo 11/14/2010 14:19'!
shouldSearchOutside

	^left ySignSameWith: right! !

BinarySearchLogic subclass: #BinarySearcherForIntegerToBoolean
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BinarySearch'!

!BinarySearcherForIntegerToBoolean classSide methodsFor: 'as yet unclassified' stamp: 'hjo 11/14/2010 13:14'!
forArray: anArray 

	|instance|
	instance := self new.
	instance left: 1.
	instance right: anArray size.
	^instance! !

!BinarySearcherForIntegerToBoolean methodsFor: 'accessing' stamp: 'hjo 11/14/2010 14:24'!
equation: aBlockContext 

	super equation: [:x| (aBlockContext value:x) ifTrue: [1] ifFalse: [-1]]! !

!BinarySearcherForIntegerToBoolean methodsFor: 'as yet unclassified' stamp: 'hjo 11/14/2010 13:54'!
jumpToMiddleOfLeftAndRight
	
	| new |
	
	new := self newPointOnFunction.

	new x: ((left x+right x)/2) truncated.
	(new y = left y) ifTrue: [ left := new. ^self ].
	(new y = right y) ifTrue: [ right := new ]! !

!BinarySearcherForIntegerToBoolean methodsFor: 'as yet unclassified' stamp: 'hjo 11/21/2010 12:32'!
jumpToOutsideOfLeftAndRight
	
	| displacement outLeft outRight changed |
	displacement := right x - left x.
	
	[
		self assert: [displacement > 0].
		outLeft := self newPointOnFunction.
		outLeft x: left x - displacement.
		outRight := self newPointOnFunction.
		outRight x: right x + displacement.
	
		changed := false.
		([outLeft y. false] on: Error do: [true])
			ifFalse: [left := outLeft. changed := true].
	
		([outRight y. false] on: Error do: [true])
			ifFalse: [right := outRight. changed := true].
		changed 
	] 
		whileFalse: 
	[	displacement := displacement // 2	]
	"i want to refactor to [outLeft y] raises: Error"! !

!BinarySearcherForIntegerToBoolean methodsFor: 'as yet unclassified' stamp: 'hjo 11/14/2010 13:59'!
loopCondition

	^(left x + 1 = right x and: [ left y ~= right y ]) not! !

!BinarySearcherForIntegerToBoolean methodsFor: 'as yet unclassified' stamp: 'hjo 11/14/2010 14:08'!
run

	[self step] whileTrue.
	root := left.! !

!BinarySearcherForIntegerToBoolean methodsFor: 'as yet unclassified' stamp: 'hjo 11/14/2010 14:19'!
shouldSearchOutside

	^left y = right y! !

Object subclass: #PointOnFunction
	instanceVariableNames: 'eq x y'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BinarySearch'!

!PointOnFunction methodsFor: 'as yet unclassified' stamp: 'hjo 3/24/2008 10:27'!
biggerYAbsolute: aPointOnFunction 

	^self y abs > aPointOnFunction y abs
		ifTrue: [ self ]
		ifFalse: [ aPointOnFunction  ]! !

!PointOnFunction methodsFor: 'as yet unclassified' stamp: 'hjo 3/24/2008 10:27'!
equation

	^eq! !

!PointOnFunction methodsFor: 'as yet unclassified' stamp: 'hjo 3/24/2008 10:27'!
equation: aBlock

	eq := aBlock! !

!PointOnFunction methodsFor: 'as yet unclassified' stamp: 'hjo 3/24/2008 10:27'!
printOn: aStream

	super printOn: aStream.
	aStream nextPut: $(.
	aStream print: self x.
	aStream nextPut: $@.
	aStream print: self y.
	aStream nextPut: $)! !

!PointOnFunction methodsFor: 'as yet unclassified' stamp: 'hjo 3/24/2008 10:27'!
smallerYAbsolute: aPointOnFunction 

	^self y abs <= aPointOnFunction y abs
		ifTrue: [ self ]
		ifFalse: [ aPointOnFunction  ]! !

!PointOnFunction methodsFor: 'as yet unclassified' stamp: 'hjo 3/24/2008 10:27'!
x

	^x! !

!PointOnFunction methodsFor: 'as yet unclassified' stamp: 'hjo 3/24/2008 10:27'!
x: aNumber

	y := nil.
	x := aNumber! !

!PointOnFunction methodsFor: 'as yet unclassified' stamp: 'hjo 3/24/2008 10:27'!
y

	(y isNil and: [ self equation notNil ]) ifTrue: [ y := self equation value: self x ].
	^y! !

!PointOnFunction methodsFor: 'as yet unclassified' stamp: 'hjo 3/24/2008 10:27'!
ySignSameWith: aPointOnFunction 

	^self y * aPointOnFunction y > 0! !

TestCase subclass: #BinarySearcherTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BinarySearch'!

!BinarySearcherTest methodsFor: 'as yet unclassified' stamp: 'hjo 6/11/2011 21:11'!
test1

	|b|
	(b := BinarySearcher new)
		left: 1.0;
		right: 3.0;
		equation: [:x| x negated raisedTo: 3];
		accuracy: 0.0000000001.
	self assert: b solve equals: 0

! !

!BinarySearcherTest methodsFor: 'as yet unclassified' stamp: 'hjo 3/24/2008 10:27'!
test2

	|b|

	(b := BinarySearcher new)
		left: 0.5;
		right: 3.0;
		equation: [:x| x negated raisedTo: 3];
		accuracy: 0.0000000001.
	self assert: (b value: b solve) < b accuracy
! !

!BinarySearcherTest methodsFor: 'as yet unclassified' stamp: 'hjo 11/14/2010 14:27'!
testForIntegerDomain

	|b array |
	array := #(3 2 1 3 1 2 3 110 200 105).
	b := BinarySearcherForIntegerToBoolean forArray: array.
	b equation: [:x| (array at:x) > 100 ].
	self assert: b solve = 7! !

!BinarySearcherTest methodsFor: 'as yet unclassified' stamp: 'hjo 6/11/2011 21:11'!
testPointOnFunction

	|p|
	p := PointOnFunction new.
	p x: 1.
	self assert: p x = 1.
	p x: 2.
	self assert: p x equals: 2.! !

!BinarySearcherTest methodsFor: 'as yet unclassified' stamp: 'hjo 6/11/2011 21:11'!
testPointOnFunctionRecalculateY

	|p|
	p := PointOnFunction new.
	p x: 2.
	p equation: [:x| x squared ].
	p x: 3.
	self assert: p y equals: 9.
! !

!BinarySearcherTest methodsFor: 'as yet unclassified' stamp: 'hjo 6/11/2011 21:12'!
testPointOnFunctionY

	|p|
	p := PointOnFunction new.
	p x: 2.
	p equation: [:x| x squared ].
	self assert: p y equals: 4.
! !

!BinarySearcherTest methodsFor: 'as yet unclassified' stamp: 'hjo 3/24/2008 10:27'!
testSteppingEqualsSolve

	|b steppingRoot solveRoot|

	(b := BinarySearcher new)
		left: 0.5;
		right: 3.0;
		equation: [:x| x negated raisedTo: 3];
		accuracy: 0.0000000001.

	[b step] whileTrue.
	steppingRoot := b root x.

	(b := BinarySearcher new)
		left: 0.5;
		right: 3.0;
		equation: [:x| x negated raisedTo: 3];
		accuracy: 0.0000000001.

	solveRoot := b solve.

	self assert: steppingRoot = solveRoot
	! !
